//	Copyright (c) 1994, University of Kansas, All Rights Reserved
//
//	Class:		TextAttribute
//	Include File:	textattr.h
//	Purpose:	Implement a way of giving a WWW style of attribute to
//			a segment of a stream of data.
//	Remarks/Portability/Dependencies/Restrictions:
//		The difference between the start and end of an attribute is
//		called extent.  Extent can be considered a correlation to
//		calling strlen on a string.
//		An extent of 0 means no duration, 1 means 1 byte, etc...
//		A negative extent is equivalent to 0 extent.
//		Once an attribute type is set by the constructor, it can
//		never be changed.
//	Revision History:
//		02-01-94	created
//		02-09-94	Split all members into seperate files.
#include"textattr.h"

void TextAttribute::End(const signed long int sli_OffsetPlusExtent)
{
//	Purpose:	Set the ending of an attribute in a stream.
//	Arguments:	sli_OffsetPlusExtent	The ending stream offset.
//	Return Value:	void
//	Remarks/Portability/Dependencies/Restrictions:
//		Provides a mechanism for change.
//		This in no way will change the beginning offset into the
//		stream unless specifically adjusted also.
//	Revision History:
//		02-01-94	created.

	sli_StreamExtent = sli_OffsetPlusExtent;
}
